<template>
  <transition name="fade">
    <div v-if="show" class="modal">
      <div class="modal__layout">
        <div class="modal__dialog">
          <button @click="$emit('close-modal')" class="modal__close"></button>
          <div class="modal__inner">
            <h4 class="modal__title">Please answer a few questions</h4>
            <slot></slot>
          </div>
        </div>
      </div>
    </div>
  </transition>
</template>
<script>
export default {
  name: "Modal",
  components: {},
  emits: ["close-modal"],
  props: {
    show: {
      type: Boolean,
      default: false,
    },
  },
};
</script>
<style lang="scss">
.modal {
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  z-index: 9999;
  position: fixed;
  box-sizing: inherit;
  background-color: rgba(26, 26, 26, 0.4);
  &__layout {
    width: 100%;
    display: flex;
    min-height: 100%;
    align-items: flex-start;
    justify-content: center;
    box-sizing: inherit;
  }
  &__inner {
    box-sizing: inherit;
  }
  &__dialog {
    width: 100%;
    max-width: 600px;
    position: relative;
    padding: 32px 40px 40px;
    margin-top: calc(100vh / 7);
    transform: translate(0, 0);
    box-sizing: inherit;
    background: #f5f5f5;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25);
    border-radius: 5px;
  }
  &__close {
    top: 0;
    right: 0;
    width: 44px;
    height: 44px;
    border: none;
    display: flex;
    padding: 10px;
    cursor: pointer;
    position: absolute;
    background: transparent url("../assets/close.svg") no-repeat center;
    background-size: 14px;
    box-sizing: inherit;
  }
  &__title {
    font-size: 18px;
    font-weight: 700;
    text-align: center;
    margin-bottom: 50px;
  }
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.15s linear;
  .modal__dialog {
    transition: transform 0.2s ease-out;
  }
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
  .modal__dialog {
    transform: translate(0, -10%);
  }
}
</style>